#Region-Splash-And-Icon---------------------------------------------------------
#AutoIt3Wrapper_Icon=C:\Documents and Settings\Milo\Desktop\data, assorted\autoit scripts\Double Click icon and logo\doubleclick.ico
#AutoIt3Wrapper_Res_Comment=www.wz2100.net The site of the best game on earth!
#AutoIt3Wrapper_Res_Description=Warzone 2100 Mod Manager v4
#AutoIt3Wrapper_Res_Fileversion=4.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Copyright 2009 by Milo Christiansen
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_Field=Company|Double Click Technologies
SplashImageOn("", @ScriptDir & "\splash4.0.gif", 400, 300, -1, -1, 1)
Sleep(2000)
SplashOff()
#EndRegion-Splash-And-Icon------------------------------------------------------
#Region Header
;Header-Start-------------------------------------------------------------------
;
; AutoIt Version: 3.3.0.0
; Author:         Milo Christiansen
;
; Script Function:
;			Warzone 2100 Mod Manager version 4.0
;
;Header-End---------------------------------------------------------------------

;Includes-Start-----------------------------------------------------------------

#include <MSG.au3> ;my custom msgbox library

#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

#include <GuiListBox.au3>
#include <GuiEdit.au3>
#include <File.au3>

;Includes-End-------------------------------------------------------------------

;Options-Start------------------------------------------------------------------

Opt("MustDeclareVars", 1)

;Options-End--------------------------------------------------------------------
#EndRegion Header
;General-Declerations-Start-----------------------------------------------------

Dim $winMain
#Region CTRL Handles
Dim $hMainTab

Dim $tabMod1
Dim $hUseMod1
Dim $hMod1Logo
Dim $hChooseMod1
Dim $hMod1Description
Dim $hMod1Readme
Dim $hMod1Folder
Dim $hMP1
Dim $hSP1
Dim $hGlobal1

Dim $tabMod2
Dim $hUseMod2
Dim $hMod2Logo
Dim $hChooseMod2
Dim $hMod2Description
Dim $hMod2Readme
Dim $hMod2Folder
Dim $hMP2
Dim $hSP2
Dim $hGlobal2

Dim $tabMod3
Dim $hUseMod3
Dim $hMod3Logo
Dim $hChooseMod3
Dim $hMod3Description
Dim $hMod3Readme
Dim $hMod3Folder
Dim $hMP3
Dim $hSP3
Dim $hGlobal3

Dim $tabMod4
Dim $hUseMod4
Dim $hMod4Logo
Dim $hChooseMod4
Dim $hMod4Description
Dim $hMod4Readme
Dim $hMod4Folder
Dim $hMP4
Dim $hSP4
Dim $hGlobal4

Dim $tabMod5
Dim $hUseMod5
Dim $hMod5Logo
Dim $hChooseMod5
Dim $hMod5Description
Dim $hMod5Readme
Dim $hMod5Folder
Dim $hMP5
Dim $hSP5
Dim $hGlobal5

Dim $tabSETandConfig
Dim $hConfigEdit
Dim $hConfigSave
Dim $hChooseSetting
Dim $hCreateSetting
Dim $hSaveSetting
Dim $hDeleteSetting
Dim $hLoadSetting

Dim $tabWZMODFiles
Dim $hModFilePath
Dim $hBrowseForMod
Dim $hModLogoPath
Dim $hBrowseForLogo
Dim $hReadmePath
Dim $hBrowseForReadme
Dim $hEnterModDescription
Dim $hModName
Dim $hModAuthor
Dim $hCreateWZMOD
Dim $hMPwz
Dim $hSPwz
Dim $hGlobalwz

Dim $hOtherCommands
Dim $hRunWz
Dim $hMod1Display
Dim $hMod1State
Dim $hMod2Display
Dim $hMod2State
Dim $hMod3Display
Dim $hMod3State
Dim $hMod4Display
Dim $hMod4State
Dim $hMod5Display
Dim $hMod5State
Dim $hCurrentSettingFile
Dim $hCurrentCommandLine
#EndRegion CTRL Handles
;Other Global Vars And Consts
Const $DefaultLogo = @ScriptDir & "\DefaultLogo.bmp"
Dim $CurrentSetting
Dim $GameExePath
Dim $WarzoneConfigPath

;General-Declerations-End-------------------------------------------------------

;CMD-Line-Handler-Start---------------------------------------------------------

If $CmdLineRaw <> "" Then
	If $CmdLineRaw = "-Uninstall" Then
		_DELETE_WZMOD_REGISTRATION()
		Exit
	EndIf
	If FileExists(StringTrimRight(StringTrimLeft($CmdLineRaw, 1), 1)) Then
		If StringRight(StringTrimRight(StringTrimLeft($CmdLineRaw, 1), 1), 6) = ".wzmod" Then
			RunWait("""" & @ScriptDir & "\7za.exe"" e -y " & $CmdLineRaw & " -o""" & @ScriptDir & """ ModConfig.ini", "", @SW_HIDE)
			Local $ModName = IniRead(@ScriptDir & "\ModConfig.ini", "General", "ModName", "ERROR")
			If $ModName = "ERROR" Then
				MsgBox(16, "Mod Installer", "ERROR Reading """ & @ScriptDir & "\ModConfig.ini""")
				Exit
			EndIf
			FileDelete(@ScriptDir & "\ModConfig.ini")
			RunWait("""" & @ScriptDir & "\7za.exe"" e -y " & $CmdLineRaw & " -o""" & @ScriptDir & "\Mods\" & $ModName & """", "", @SW_HIDE)
			IniWrite(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", _
					"Mod" & (IniRead(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "0") + 1), $ModName)
			IniWrite(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", _
					"Count", (IniRead(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "0") + 1))
			Exit
		EndIf
	EndIf
EndIf

;CMD-Line-Handler-End-----------------------------------------------------------

;Input-Start--------------------------------------------------------------------

_SETUP()

$GameExePath = IniRead(@ScriptDir & "\Config.ini", "General", "GameExePath", "ERROR")
$WarzoneConfigPath = IniRead(@ScriptDir & "\Config.ini", "General", "GameConfigPath", "ERROR")
If $GameExePath = "ERROR" Or $WarzoneConfigPath = "ERROR" Then
	MsgBox(16, "Warzone 2100 Mod Manager", "ERROR in """ & @ScriptDir & "\Config.ini""")
	Exit
EndIf

;Input-End----------------------------------------------------------------------

;Main-Script-Start--------------------------------------------------------------

$winMain = GUICreate("Warzone 2100 Mod Manager", 869, 400, -1, -1)
#Region GUI
$hMainTab = GUICtrlCreateTab(2, 2, 587, 395)

$tabMod1 = GUICtrlCreateTabItem("Mod 1")
GUICtrlCreateLabel("Choose a mod from the list.", 8, 131, 131, 17)
GUICtrlCreateLabel("Mod Description", 283, 131, 81, 17)
$hUseMod1 = GUICtrlCreateCheckbox("Use Mod 1", 8, 28, 72, 17)
$hMod1Logo = GUICtrlCreatePic($DefaultLogo, 283, 28, 300, 100)
$hChooseMod1 = GUICtrlCreateList("", 8, 148, 270, 214)
$hMod1Description = GUICtrlCreateEdit("", 282, 148, 300, 243, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_READONLY, $ES_WANTRETURN, $WS_VSCROLL))
$hMod1Readme = GUICtrlCreateButton("Open Mod Readme", 8, 366, 130, 25, 0)
$hMod1Folder = GUICtrlCreateButton("Open Mod Folder", 148, 366, 130, 25, 0)
GUICtrlCreateGroup("Mod Scope", 8, 50, 270, 51)
GUICtrlCreateLabel("This may be limited by the mod you are using.", 13, 65, 217, 17)
$hMP1 = GUICtrlCreateRadio("Multiplayer/Skirmish", 14, 81, 115, 17)
$hSP1 = GUICtrlCreateRadio("Campaign", 138, 81, 67, 17)
$hGlobal1 = GUICtrlCreateRadio("Global", 218, 81, 55, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$tabMod2 = GUICtrlCreateTabItem("Mod 2")
GUICtrlCreateLabel("Choose a mod from the list.", 8, 131, 131, 17)
GUICtrlCreateLabel("Mod Description", 283, 131, 81, 17)
$hUseMod2 = GUICtrlCreateCheckbox("Use Mod 2", 8, 28, 72, 17)
$hMod2Logo = GUICtrlCreatePic($DefaultLogo, 283, 28, 300, 100)
$hChooseMod2 = GUICtrlCreateList("", 8, 148, 270, 214)
$hMod2Description = GUICtrlCreateEdit("", 282, 148, 300, 243, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_READONLY, $ES_WANTRETURN, $WS_VSCROLL))
$hMod2Readme = GUICtrlCreateButton("Open Mod Readme", 8, 366, 130, 25, 0)
$hMod2Folder = GUICtrlCreateButton("Open Mod Folder", 148, 366, 130, 25, 0)
GUICtrlCreateGroup("Mod Scope", 8, 50, 270, 51)
GUICtrlCreateLabel("This may be limited by the mod you are using.", 13, 65, 217, 17)
$hMP2 = GUICtrlCreateRadio("Multiplayer/Skirmish", 14, 81, 115, 17)
$hSP2 = GUICtrlCreateRadio("Campaign", 138, 81, 67, 17)
$hGlobal2 = GUICtrlCreateRadio("Global", 218, 81, 55, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$tabMod3 = GUICtrlCreateTabItem("Mod 3")
GUICtrlCreateLabel("Choose a mod from the list.", 8, 131, 131, 17)
GUICtrlCreateLabel("Mod Description", 283, 131, 81, 17)
$hMod3Logo = GUICtrlCreatePic($DefaultLogo, 283, 28, 300, 100)
$hUseMod3 = GUICtrlCreateCheckbox("Use Mod 3", 8, 28, 72, 17)
$hChooseMod3 = GUICtrlCreateList("", 8, 148, 270, 214)
$hMod3Description = GUICtrlCreateEdit("", 282, 148, 300, 243, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_READONLY, $ES_WANTRETURN, $WS_VSCROLL))
$hMod3Readme = GUICtrlCreateButton("Open Mod Readme", 8, 366, 130, 25, 0)
$hMod3Folder = GUICtrlCreateButton("Open Mod Folder", 148, 366, 130, 25, 0)
GUICtrlCreateGroup("Mod Scope", 8, 50, 270, 51)
GUICtrlCreateLabel("This may be limited by the mod you are using.", 13, 65, 217, 17)
$hMP3 = GUICtrlCreateRadio("Multiplayer/Skirmish", 14, 81, 115, 17)
$hSP3 = GUICtrlCreateRadio("Campaign", 138, 81, 67, 17)
$hGlobal3 = GUICtrlCreateRadio("Global", 218, 81, 55, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$tabMod4 = GUICtrlCreateTabItem("Mod 4")
GUICtrlCreateLabel("Choose a mod from the list.", 8, 131, 131, 17)
GUICtrlCreateLabel("Mod Description", 283, 131, 81, 17)
$hUseMod4 = GUICtrlCreateCheckbox("Use Mod 4", 8, 28, 72, 17)
$hMod4Logo = GUICtrlCreatePic($DefaultLogo, 283, 28, 300, 100)
$hChooseMod4 = GUICtrlCreateList("", 8, 148, 270, 214)
$hMod4Description = GUICtrlCreateEdit("", 282, 148, 300, 243, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_READONLY, $ES_WANTRETURN, $WS_VSCROLL))
$hMod4Readme = GUICtrlCreateButton("Open Mod Readme", 8, 366, 130, 25, 0)
$hMod4Folder = GUICtrlCreateButton("Open Mod Folder", 148, 366, 130, 25, 0)
GUICtrlCreateGroup("Mod Scope", 8, 50, 270, 51)
GUICtrlCreateLabel("This may be limited by the mod you are using.", 13, 65, 217, 17)
$hMP4 = GUICtrlCreateRadio("Multiplayer/Skirmish", 14, 81, 115, 17)
$hSP4 = GUICtrlCreateRadio("Campaign", 138, 81, 67, 17)
$hGlobal4 = GUICtrlCreateRadio("Global", 218, 81, 55, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$tabMod5 = GUICtrlCreateTabItem("Mod 5")
GUICtrlCreateLabel("Choose a mod from the list.", 8, 131, 131, 17)
GUICtrlCreateLabel("Mod Description", 283, 131, 81, 17)
$hUseMod5 = GUICtrlCreateCheckbox("Use Mod 5", 8, 28, 72, 17)
$hMod5Logo = GUICtrlCreatePic($DefaultLogo, 283, 28, 300, 100)
$hChooseMod5 = GUICtrlCreateList("", 8, 148, 270, 214)
$hMod5Description = GUICtrlCreateEdit("", 282, 148, 300, 243, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_READONLY, $ES_WANTRETURN, $WS_VSCROLL))
$hMod5Readme = GUICtrlCreateButton("Open Mod Readme", 8, 366, 130, 25, 0)
$hMod5Folder = GUICtrlCreateButton("Open Mod Folder", 148, 366, 130, 25, 0)
GUICtrlCreateGroup("Mod Scope", 8, 50, 270, 51)
GUICtrlCreateLabel("This may be limited by the mod you are using.", 13, 65, 217, 17)
$hMP5 = GUICtrlCreateRadio("Multiplayer/Skirmish", 14, 81, 115, 17)
$hSP5 = GUICtrlCreateRadio("Campaign", 138, 81, 67, 17)
$hGlobal5 = GUICtrlCreateRadio("Global", 218, 81, 55, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$tabSETandConfig = GUICtrlCreateTabItem(".set Files and the Warzone Config File")
GUICtrlCreateGroup("Warzone Config File", 213, 28, 370, 362)
$hConfigEdit = GUICtrlCreateEdit("", 219, 49, 358, 305, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_WANTRETURN, $WS_VSCROLL))
$hConfigSave = GUICtrlCreateButton("Save Changes", 219, 361, 358, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$hChooseSetting = GUICtrlCreateList("", 8, 162, 200, 227)
$hCreateSetting = GUICtrlCreateButton("Create New Setting File", 8, 28, 200, 25, 0)
$hSaveSetting = GUICtrlCreateButton("Save Settings to Selected File", 8, 58, 200, 25, 0)
$hDeleteSetting = GUICtrlCreateButton("Delete Selected Setting File", 8, 87, 200, 25, 0)
$hLoadSetting = GUICtrlCreateButton("Load Selected Setting File", 8, 117, 200, 25, 0)
GUICtrlCreateLabel("Choose Setting File", 8, 147, 95, 17)

$tabWZMODFiles = GUICtrlCreateTabItem(".wzmod File Creation")
GUICtrlCreateLabel(".wz File Path", 8, 30, 64, 17)
GUICtrlCreateLabel("Mod Logo Path", 8, 57, 77, 17)
GUICtrlCreateLabel("Readme Path", 8, 85, 69, 17)
GUICtrlCreateLabel("Enter Mod Description", 281, 110, 109, 17)
GUICtrlCreateLabel("Mod Name", 8, 125, 56, 17)
GUICtrlCreateLabel("Mod Author", 8, 173, 59, 17)
$hModFilePath = GUICtrlCreateInput("", 84, 28, 443, 21)
$hBrowseForMod = GUICtrlCreateButton("Browse", 532, 28, 50, 21, 0)
$hModLogoPath = GUICtrlCreateInput("", 84, 55, 443, 21)
$hBrowseForLogo = GUICtrlCreateButton("Browse", 532, 55, 50, 21, 0)
$hReadmePath = GUICtrlCreateInput("", 84, 82, 443, 21)
$hBrowseForReadme = GUICtrlCreateButton("Browse", 532, 82, 50, 21, 0)
$hEnterModDescription = GUICtrlCreateEdit("", 281, 127, 300, 263, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_WANTRETURN, $WS_VSCROLL))
$hModName = GUICtrlCreateInput("", 8, 142, 150, 21)
$hModAuthor = GUICtrlCreateInput("", 8, 190, 150, 21)
$hCreateWZMOD = GUICtrlCreateButton("Create .wzmod File", 8, 289, 270, 25, 0)
GUICtrlCreateGroup("Mod Scope", 8, 219, 270, 64)
GUICtrlCreateLabel("Choose The Mods Scope", 13, 234, 125, 17)
GUICtrlCreateLabel("Don't choose a scope to leave this up to the player.", 14, 248, 247, 17)
$hMPwz = GUICtrlCreateRadio("Multiplayer/Skirmish", 14, 263, 115, 17)
$hSPwz = GUICtrlCreateRadio("Campaign", 138, 263, 67, 17)
$hGlobalwz = GUICtrlCreateRadio("Global", 218, 263, 55, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)


GUICtrlCreateTabItem("")

GUICtrlCreateLabel("Other Command Line Options", 596, 322, 142, 13)
$hOtherCommands = GUICtrlCreateInput("", 595, 337, 270, 21)

$hRunWz = GUICtrlCreateButton("Run Warzone 2100!", 595, 364, 270, 30, 0)

GUICtrlCreateGroup("Displays", 595, 16, 270, 304)
GUICtrlCreateLabel("Mod 1 Current Setting", 601, 31, 107, 17)
$hMod1Display = GUICtrlCreateInput("", 601, 50, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod1State = GUICtrlCreateInput("", 756, 50, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlCreateLabel("Mod 2 Current Setting", 601, 76, 107, 17)
$hMod2Display = GUICtrlCreateInput("", 601, 93, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod2State = GUICtrlCreateInput("", 756, 93, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlCreateLabel("Mod 3 Current Setting", 601, 120, 107, 17)
$hMod3Display = GUICtrlCreateInput("", 601, 139, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod3State = GUICtrlCreateInput("", 756, 139, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlCreateLabel("Mod 4 Current Setting", 601, 165, 107, 17)
$hMod4Display = GUICtrlCreateInput("", 601, 182, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod4State = GUICtrlCreateInput("", 756, 182, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlCreateLabel("Mod 5 Current Setting", 601, 207, 107, 17)
$hMod5Display = GUICtrlCreateInput("", 601, 224, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod5State = GUICtrlCreateInput("", 756, 224, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlCreateLabel("Selected Setting File", 601, 253, 99, 17)
$hCurrentSettingFile = GUICtrlCreateInput("", 702, 250, 156, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlCreateLabel("Current Command Line", 601, 275, 111, 16)
$hCurrentCommandLine = GUICtrlCreateInput("", 601, 292, 257, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
GUICtrlCreateGroup("", -99, -99, 1, 1)
#EndRegion GUI
GUISetState(@SW_SHOW)

_REFRESH_LIST_BOXES()
_UPDATE_DATA_DISPLAY_CMDLINE()
_LOAD_WARZONE_CONFIG()

#Region Inital States
GUICtrlSetState($hMP1, $GUI_DISABLE)
GUICtrlSetState($hSP1, $GUI_DISABLE)
GUICtrlSetState($hGlobal1, $GUI_DISABLE)
GUICtrlSetState($hChooseMod1, $GUI_DISABLE)
GUICtrlSetState($hMP2, $GUI_DISABLE)
GUICtrlSetState($hSP2, $GUI_DISABLE)
GUICtrlSetState($hGlobal2, $GUI_DISABLE)
GUICtrlSetState($hChooseMod2, $GUI_DISABLE)
GUICtrlSetState($hMP3, $GUI_DISABLE)
GUICtrlSetState($hSP3, $GUI_DISABLE)
GUICtrlSetState($hGlobal3, $GUI_DISABLE)
GUICtrlSetState($hChooseMod3, $GUI_DISABLE)
GUICtrlSetState($hMP4, $GUI_DISABLE)
GUICtrlSetState($hSP4, $GUI_DISABLE)
GUICtrlSetState($hGlobal4, $GUI_DISABLE)
GUICtrlSetState($hChooseMod4, $GUI_DISABLE)
GUICtrlSetState($hMP5, $GUI_DISABLE)
GUICtrlSetState($hSP5, $GUI_DISABLE)
GUICtrlSetState($hGlobal5, $GUI_DISABLE)
GUICtrlSetState($hChooseMod5, $GUI_DISABLE)
#EndRegion Inital States
;
;MSG loop
While 1
	Local $Msg = GUIGetMsg()
	Switch $Msg
		Case $GUI_EVENT_CLOSE
			Exit

			;Mod 1
		Case $hGlobal1
			_UPDATE_DATA_DISPLAY_1()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hSP1
			_UPDATE_DATA_DISPLAY_1()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMP1
			_UPDATE_DATA_DISPLAY_1()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hChooseMod1
			_UPDATE_LOGO_1()
			_UPDATE_DESCRIPTION_1()
			_LIMIT_SCOPE_1()
			_UPDATE_DATA_DISPLAY_1()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hUseMod1
			_ToggleMod1()
			_LIMIT_SCOPE_1()
			_UPDATE_DATA_DISPLAY_1()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMod1Readme
			_OPEN_README_1()
		Case $hMod1Folder
			_OPEN_FOLDER_1()

			;Mod 2
		Case $hGlobal2
			_UPDATE_DATA_DISPLAY_2()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hSP2
			_UPDATE_DATA_DISPLAY_2()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMP2
			_UPDATE_DATA_DISPLAY_2()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hChooseMod2
			_UPDATE_LOGO_2()
			_UPDATE_DESCRIPTION_2()
			_LIMIT_SCOPE_2()
			_UPDATE_DATA_DISPLAY_2()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hUseMod2
			_ToggleMod2()
			_LIMIT_SCOPE_2()
			_UPDATE_DATA_DISPLAY_2()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMod2Readme
			_OPEN_README_2()
		Case $hMod2Folder
			_OPEN_FOLDER_2()

			;Mod 3
		Case $hGlobal3
			_UPDATE_DATA_DISPLAY_3()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hSP3
			_UPDATE_DATA_DISPLAY_3()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMP3
			_UPDATE_DATA_DISPLAY_3()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hChooseMod3
			_UPDATE_LOGO_3()
			_UPDATE_DESCRIPTION_3()
			_LIMIT_SCOPE_3()
			_UPDATE_DATA_DISPLAY_3()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hUseMod3
			_ToggleMod3()
			_LIMIT_SCOPE_3()
			_UPDATE_DATA_DISPLAY_3()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMod3Readme
			_OPEN_README_3()
		Case $hMod3Folder
			_OPEN_FOLDER_3()

			;Mod 4
		Case $hGlobal4
			_UPDATE_DATA_DISPLAY_4()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hSP4
			_UPDATE_DATA_DISPLAY_4()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMP4
			_UPDATE_DATA_DISPLAY_4()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hChooseMod4
			_UPDATE_LOGO_4()
			_UPDATE_DESCRIPTION_4()
			_LIMIT_SCOPE_4()
			_UPDATE_DATA_DISPLAY_4()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hUseMod4
			_ToggleMod4()
			_LIMIT_SCOPE_4()
			_UPDATE_DATA_DISPLAY_4()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMod4Readme
			_OPEN_README_4()
		Case $hMod4Folder
			_OPEN_FOLDER_4()

			;Mod 5
		Case $hGlobal5
			_UPDATE_DATA_DISPLAY_5()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hSP5
			_UPDATE_DATA_DISPLAY_5()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMP5
			_UPDATE_DATA_DISPLAY_5()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hChooseMod5
			_UPDATE_LOGO_5()
			_UPDATE_DESCRIPTION_5()
			_LIMIT_SCOPE_5()
			_UPDATE_DATA_DISPLAY_5()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hUseMod5
			_ToggleMod5()
			_LIMIT_SCOPE_5()
			_UPDATE_DATA_DISPLAY_5()
			_UPDATE_DATA_DISPLAY_CMDLINE()
		Case $hMod5Readme
			_OPEN_README_5()
		Case $hMod5Folder
			_OPEN_FOLDER_5()

			;Warzone Config
		Case $hConfigSave
			_SAVE_WARZONE_CONFIG()

			;Settings
		Case $hCreateSetting
			_CREATE_SETTING_FILE()
			_UPDATE_DATA_DISPLAY_ALL()
		Case $hSaveSetting
			_SAVE_SETTINGS()
		Case $hDeleteSetting
			Local $RTN
			$RTN = MsgBox(36, "Delete Setting", "Delete setting file?")
			If $RTN = 6 Then
				FileDelete($CurrentSetting)
				MsgBox(0, "Delete Setting", "Setting file deleted.")
				_REFRESH_LIST_BOX_SETTING()
				_UPDATE_DATA_DISPLAY_SETTING()
			EndIf
		Case $hChooseSetting
			$CurrentSetting = (@ScriptDir & "\Setting Files\" & GUICtrlRead($hChooseSetting))
			_UPDATE_DATA_DISPLAY_SETTING()
		Case $hLoadSetting
			_LOAD_SETTINGS()
			_UPDATE_DATA_DISPLAY_ALL()

			;WZMOD creation
		Case $hBrowseForMod
			GUICtrlSetData($hModFilePath, FileOpenDialog("Warzone 2100 Mod Manager .wzmod Creator", @HomeDrive, "Warzone Mods (*.wz)", 1))
		Case $hBrowseForLogo
			GUICtrlSetData($hModLogoPath, FileOpenDialog("Warzone 2100 Mod Manager .wzmod Creator", @HomeDrive, "Bitmap Images (*.bmp)", 1))
		Case $hBrowseForReadme
			GUICtrlSetData($hReadmePath, FileOpenDialog("Warzone 2100 Mod Manager .wzmod Creator", @HomeDrive, "Text Files (*.txt)", 1))
		Case $hCreateWZMOD
			_CREATE_WZMOD()

			;Other
		Case $hRunWz
			_RUN()
		Case $hOtherCommands
			_UPDATE_DATA_DISPLAY_CMDLINE()
	EndSwitch
WEnd

;Main-Script-End----------------------------------------------------------------

;Function-Decleration-Start-----------------------------------------------------

Func _RUN()

	Local $Mod1
	Local $Mod2
	Local $Mod3
	Local $Mod4
	Local $Mod5
	Local $Mod1Name
	Local $Mod2Name
	Local $Mod3Name
	Local $Mod4Name
	Local $Mod5Name
	Local $Mod1FileName
	Local $Mod2FileName
	Local $Mod3FileName
	Local $Mod4FileName
	Local $Mod5FileName

	If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod1) <> "" Then
			If GUICtrlRead($hSP1) = $GUI_CHECKED Or GUICtrlRead($hMP1) = $GUI_CHECKED Or GUICtrlRead($hGlobal1) = $GUI_CHECKED Then
				$Mod1Name = GUICtrlRead($hChooseMod1)
				If FileExists(@ScriptDir & "\Mods\" & $Mod1Name) And StringRight($Mod1Name, 3) <> ".wz" Then
					$Mod1FileName = IniRead(@ScriptDir & "\Mods\" & $Mod1Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod1FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod1Name) And StringRight($Mod1Name, 3) = ".wz" Then
					$Mod1FileName = $Mod1Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP1) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod1Name, "SP", $GameExePath)
						$Mod1 = ' --mod_ca "' & $Mod1FileName & '"'
					Case GUICtrlRead($hMP1) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod1Name, "MP", $GameExePath)
						$Mod1 = ' --mod_mp "' & $Mod1FileName & '"'
					Case GUICtrlRead($hGlobal1) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod1Name, "GLOBAL", $GameExePath)
						$Mod1 = ' --mod "' & $Mod1FileName & '"'
				EndSelect
			Else
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod2) <> "" Then
			If GUICtrlRead($hSP2) = $GUI_CHECKED Or GUICtrlRead($hMP2) = $GUI_CHECKED Or GUICtrlRead($hGlobal2) = $GUI_CHECKED Then
				$Mod2Name = GUICtrlRead($hChooseMod2)
				If FileExists(@ScriptDir & "\Mods\" & $Mod2Name) And StringRight($Mod2Name, 3) <> ".wz" Then
					$Mod2FileName = IniRead(@ScriptDir & "\Mods\" & $Mod2Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod2FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod2Name) And StringRight($Mod2Name, 3) = ".wz" Then
					$Mod2FileName = $Mod2Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP2) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod2Name, "SP", $GameExePath)
						$Mod2 = ' --mod_ca "' & $Mod2FileName & '"'
					Case GUICtrlRead($hMP2) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod2Name, "MP", $GameExePath)
						$Mod2 = ' --mod_mp "' & $Mod2FileName & '"'
					Case GUICtrlRead($hGlobal2) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod2Name, "GLOBAL", $GameExePath)
						$Mod2 = ' --mod "' & $Mod2FileName & '"'
				EndSelect
			Else
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod3) <> "" Then
			If GUICtrlRead($hSP3) = $GUI_CHECKED Or GUICtrlRead($hMP3) = $GUI_CHECKED Or GUICtrlRead($hGlobal3) = $GUI_CHECKED Then
				$Mod3Name = GUICtrlRead($hChooseMod3)
				If FileExists(@ScriptDir & "\Mods\" & $Mod1Name) And StringRight($Mod1Name, 3) <> ".wz" Then
					$Mod3FileName = IniRead(@ScriptDir & "\Mods\" & $Mod3Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod3FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod3Name) And StringRight($Mod3Name, 3) = ".wz" Then
					$Mod3FileName = $Mod3Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP3) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod3Name, "SP", $GameExePath)
						$Mod3 = ' --mod_ca "' & $Mod3FileName & '"'
					Case GUICtrlRead($hMP3) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod3Name, "MP", $GameExePath)
						$Mod3 = ' --mod_mp "' & $Mod3FileName & '"'
					Case GUICtrlRead($hGlobal3) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod3Name, "GLOBAL", $GameExePath)
						$Mod3 = ' --mod "' & $Mod3FileName & '"'
				EndSelect
			Else
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod4) <> "" Then
			If GUICtrlRead($hSP4) = $GUI_CHECKED Or GUICtrlRead($hMP4) = $GUI_CHECKED Or GUICtrlRead($hGlobal4) = $GUI_CHECKED Then
				$Mod4Name = GUICtrlRead($hChooseMod4)
				If FileExists(@ScriptDir & "\Mods\" & $Mod4Name) And StringRight($Mod4Name, 3) <> ".wz" Then
					$Mod4FileName = IniRead(@ScriptDir & "\Mods\" & $Mod4Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod4FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod4Name) And StringRight($Mod4Name, 3) = ".wz" Then
					$Mod4FileName = $Mod4Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP4) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod4Name, "SP", $GameExePath)
						$Mod4 = ' --mod_ca "' & $Mod4FileName & '"'
					Case GUICtrlRead($hMP4) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod4Name, "MP", $GameExePath)
						$Mod4 = ' --mod_mp "' & $Mod4FileName & '"'
					Case GUICtrlRead($hGlobal4) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod4Name, "GLOBAL", $GameExePath)
						$Mod4 = ' --mod "' & $Mod4FileName & '"'
				EndSelect
			Else
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod5) <> "" Then
			If GUICtrlRead($hSP5) = $GUI_CHECKED Or GUICtrlRead($hMP5) = $GUI_CHECKED Or GUICtrlRead($hGlobal5) = $GUI_CHECKED Then
				$Mod5Name = GUICtrlRead($hChooseMod5)
				If FileExists(@ScriptDir & "\Mods\" & $Mod5Name) And StringRight($Mod5Name, 3) <> ".wz" Then
					$Mod5FileName = IniRead(@ScriptDir & "\Mods\" & $Mod5Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod5FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod5Name) And StringRight($Mod5Name, 3) = ".wz" Then
					$Mod5FileName = $Mod5Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP5) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod5Name, "SP", $GameExePath)
						$Mod5 = ' --mod_ca "' & $Mod5FileName & '"'
					Case GUICtrlRead($hMP5) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod5Name, "MP", $GameExePath)
						$Mod5 = ' --mod_mp "' & $Mod5FileName & '"'
					Case GUICtrlRead($hGlobal5) = $GUI_CHECKED
						_INSTALL_TO_WARZONE_MOD_FOLDER($Mod5Name, "GLOBAL", $GameExePath)
						$Mod5 = ' --mod "' & $Mod5FileName & '"'
				EndSelect
			Else
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf
		EndIf
	EndIf

	;Run Warzone
	ShellExecute($GameExePath, $Mod1 & $Mod2 & $Mod3 & $Mod4 & $Mod5 & " " & StringStripWS(GUICtrlRead($hOtherCommands), 7))
	Exit

EndFunc   ;==>_RUN

Func _CREATE_WZMOD()
	If GUICtrlRead($hModFilePath) <> "" Then

		If GUICtrlRead($hModName) <> "" Then

			If FileExists(GUICtrlRead($hModFilePath)) Then
				DirCreate(@ScriptDir & "\temp")
				IniWrite(@ScriptDir & "\temp\ModConfig.ini", "General", "ModName", GUICtrlRead($hModName))
				IniWrite(@ScriptDir & "\temp\ModConfig.ini", "General", "ModFileName", FileNameFromPath(GUICtrlRead($hModFilePath)))
				FileCopy(GUICtrlRead($hModFilePath), @ScriptDir & "\temp\" & FileNameFromPath(GUICtrlRead($hModFilePath)))
				If GUICtrlRead($hModLogoPath) <> "" Then
					If FileExists(GUICtrlRead($hModLogoPath)) Then
						IniWrite(@ScriptDir & "\temp\ModConfig.ini", "General", "ModLogoFileName", FileNameFromPath(GUICtrlRead($hModLogoPath)))
						FileCopy(GUICtrlRead($hModLogoPath), @ScriptDir & "\temp\" & FileNameFromPath(GUICtrlRead($hModLogoPath)))
					ElseIf GUICtrlRead($hModLogoPath) = "NA" Then
						IniWrite(@ScriptDir & "\temp\ModConfig.ini", "General", "ModLogoFileName", "NA")
					Else
						MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "You must enter a path to a valid .bmp file for use as a mod logo, or enter ""NA"".")
						DirRemove(@ScriptDir & "\temp", 1)
						Return
					EndIf
				Else
					MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "You must enter a path to a valid .bmp file for use as a mod logo, or enter ""NA"".")
					DirRemove(@ScriptDir & "\temp", 1)
					Return
				EndIf

				If GUICtrlRead($hReadmePath) <> "" Then
					If FileExists(GUICtrlRead($hReadmePath)) Then
						IniWrite(@ScriptDir & "\temp\ModConfig.ini", "General", "ReadmeFileName", FileNameFromPath(GUICtrlRead($hReadmePath)))
						FileCopy(GUICtrlRead($hReadmePath), @ScriptDir & "\temp\" & FileNameFromPath(GUICtrlRead($hReadmePath)))
					ElseIf GUICtrlRead($hReadmePath) = "NA" Then
						IniWrite(@ScriptDir & "\temp\ModConfig.ini", "General", "ReadmeFileName", "NA")
					Else
						MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "You must enter a path to a valid .txt file for use as a mod Readme, or enter ""NA"".")
						DirRemove(@ScriptDir & "\temp", 1)
						Return
					EndIf
				Else
					MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "You must enter a path to a valid .txt file for use as a mod Readme, or enter ""NA"".")
					DirRemove(@ScriptDir & "\temp", 1)
					Return
				EndIf

				If GUICtrlRead($hModAuthor) <> "" Then
					IniWrite(@ScriptDir & "\temp\ModConfig.ini", "General", "ModAuthorName", GUICtrlRead($hModAuthor))
				Else
					MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "Please enter an author name, or enter ""NA"".")
					DirRemove(@ScriptDir & "\temp", 1)
					Return
				EndIf

				If GUICtrlRead($hEnterModDescription) <> "" Then
					Local $LineCount = _GUICtrlEdit_GetLineCount($hEnterModDescription)
					Local $Count = 0
					While $Count < $LineCount
						IniWrite(@ScriptDir & "\temp\ModConfig.ini", "ModDescription", "LineCount", ($Count + 1))
						IniWrite(@ScriptDir & "\temp\ModConfig.ini", "ModDescription", "Line" & ($Count + 1), _GUICtrlEdit_GetLine($hEnterModDescription, $Count))
						$Count += 1
					WEnd
				ElseIf GUICtrlRead($hEnterModDescription) = "NA" Then
					IniWrite(@ScriptDir & "\temp\ModConfig.ini", "ModDescription", "LineCount", "NA")
				Else
					MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "Please enter a description, or enter ""NA"".")
					DirRemove(@ScriptDir & "\temp", 1)
					Return
				EndIf

				If GUICtrlRead($hMPwz) = $GUI_CHECKED Or GUICtrlRead($hSPwz) = $GUI_CHECKED Or GUICtrlRead($hGlobalwz) = $GUI_CHECKED Then
					Select
						Case GUICtrlRead($hMPwz) = $GUI_CHECKED
							IniWrite(@ScriptDir & "\temp\ModConfig.ini", "ModInfo", "ModScope", "MP")
						Case GUICtrlRead($hSPwz) = $GUI_CHECKED
							IniWrite(@ScriptDir & "\temp\ModConfig.ini", "ModInfo", "ModScope", "SP")
						Case GUICtrlRead($hGlobalwz) = $GUI_CHECKED
							IniWrite(@ScriptDir & "\temp\ModConfig.ini", "ModInfo", "ModScope", "GLOBAL")
					EndSelect
				Else
					IniWrite(@ScriptDir & "\temp\ModConfig.ini", "ModInfo", "ModScope", "NA")
				EndIf

				;Write everything to an archive then clean up the temp files
				RunWait("""" & @ScriptDir & "\7za.exe"" a """ & @ScriptDir & "\" & GUICtrlRead($hModName) _
						 & ".wzmod"" """ & @ScriptDir & "\temp\" & FileNameFromPath(GUICtrlRead($hModLogoPath)) & """ """ _
						 & @ScriptDir & "\temp\" & FileNameFromPath(GUICtrlRead($hReadmePath)) & """ """ _
						 & @ScriptDir & "\temp\" & FileNameFromPath(GUICtrlRead($hModFilePath)) & """ """ _
						 & @ScriptDir & "\temp\ModConfig.ini"" -y", "", @SW_HIDE)
				Sleep(500)
				DirRemove(@ScriptDir & "\temp", 1)
				MsgBox(0, "Warzone 2100 Mod Manager .wzmod Creator", ".wzmod file placed at """ & @ScriptDir & "\" & GUICtrlRead($hModName) & ".wzmod""")
			Else
				MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "You MUST enter a valid mod file path.")
			EndIf
		Else
			MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "You MUST enter a valid mod name.")
		EndIf
	Else
		MsgBox(48, "Warzone 2100 Mod Manager .wzmod Creator", "You MUST enter a valid mod file path.")
	EndIf
EndFunc   ;==>_CREATE_WZMOD

Func _ToggleMod1()

	If GUICtrlRead($hUseMod1) = $GUI_UNCHECKED Then
		GUICtrlSetState($hMP1, $GUI_DISABLE)
		GUICtrlSetState($hSP1, $GUI_DISABLE)
		GUICtrlSetState($hGlobal1, $GUI_DISABLE)
		GUICtrlSetState($hChooseMod1, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod1, $GUI_ENABLE)
		GUICtrlSetState($hMP1, $GUI_ENABLE)
		GUICtrlSetState($hSP1, $GUI_ENABLE)
		GUICtrlSetState($hGlobal1, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod1

Func _ToggleMod2()

	If GUICtrlRead($hUseMod2) = $GUI_UNCHECKED Then
		GUICtrlSetState($hMP2, $GUI_DISABLE)
		GUICtrlSetState($hSP2, $GUI_DISABLE)
		GUICtrlSetState($hGlobal2, $GUI_DISABLE)
		GUICtrlSetState($hChooseMod2, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod2, $GUI_ENABLE)
		GUICtrlSetState($hMP2, $GUI_ENABLE)
		GUICtrlSetState($hSP2, $GUI_ENABLE)
		GUICtrlSetState($hGlobal2, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod2

Func _ToggleMod3()

	If GUICtrlRead($hUseMod3) = $GUI_UNCHECKED Then
		GUICtrlSetState($hMP3, $GUI_DISABLE)
		GUICtrlSetState($hSP3, $GUI_DISABLE)
		GUICtrlSetState($hGlobal3, $GUI_DISABLE)
		GUICtrlSetState($hChooseMod3, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod3, $GUI_ENABLE)
		GUICtrlSetState($hMP3, $GUI_ENABLE)
		GUICtrlSetState($hSP3, $GUI_ENABLE)
		GUICtrlSetState($hGlobal3, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod3

Func _ToggleMod4()

	If GUICtrlRead($hUseMod4) = $GUI_UNCHECKED Then
		GUICtrlSetState($hMP4, $GUI_DISABLE)
		GUICtrlSetState($hSP4, $GUI_DISABLE)
		GUICtrlSetState($hGlobal4, $GUI_DISABLE)
		GUICtrlSetState($hChooseMod4, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod4, $GUI_ENABLE)
		GUICtrlSetState($hMP4, $GUI_ENABLE)
		GUICtrlSetState($hSP4, $GUI_ENABLE)
		GUICtrlSetState($hGlobal4, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod4

Func _ToggleMod5()

	If GUICtrlRead($hUseMod5) = $GUI_UNCHECKED Then
		GUICtrlSetState($hMP5, $GUI_DISABLE)
		GUICtrlSetState($hSP5, $GUI_DISABLE)
		GUICtrlSetState($hGlobal5, $GUI_DISABLE)
		GUICtrlSetState($hChooseMod5, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod5, $GUI_ENABLE)
		GUICtrlSetState($hMP5, $GUI_ENABLE)
		GUICtrlSetState($hSP5, $GUI_ENABLE)
		GUICtrlSetState($hGlobal5, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod5

Func _UPDATE_DATA_DISPLAY_ALL()

	_UPDATE_DATA_DISPLAY_1()
	_UPDATE_DATA_DISPLAY_2()
	_UPDATE_DATA_DISPLAY_3()
	_UPDATE_DATA_DISPLAY_4()
	_UPDATE_DATA_DISPLAY_5()
	_UPDATE_DATA_DISPLAY_SETTING()
	_UPDATE_DATA_DISPLAY_CMDLINE()

EndFunc   ;==>_UPDATE_DATA_DISPLAY_ALL

Func _UPDATE_DATA_DISPLAY_CMDLINE()

	Local $Mod1
	Local $Mod2
	Local $Mod3
	Local $Mod4
	Local $Mod5
	Local $Mod1Name
	Local $Mod2Name
	Local $Mod3Name
	Local $Mod4Name
	Local $Mod5Name
	Local $Mod1FileName
	Local $Mod2FileName
	Local $Mod3FileName
	Local $Mod4FileName
	Local $Mod5FileName

	If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod1) <> "" Then
			If GUICtrlRead($hSP1) = $GUI_CHECKED Or GUICtrlRead($hMP1) = $GUI_CHECKED Or GUICtrlRead($hGlobal1) = $GUI_CHECKED Then
				$Mod1Name = GUICtrlRead($hChooseMod1)
				If FileExists(@ScriptDir & "\Mods\" & $Mod1Name) And StringRight($Mod1Name, 3) <> ".wz" Then
					$Mod1FileName = IniRead(@ScriptDir & "\Mods\" & $Mod1Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod1FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod1Name) And StringRight($Mod1Name, 3) = ".wz" Then
					$Mod1FileName = $Mod1Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP1) = $GUI_CHECKED
						$Mod1 = ' --mod_ca "' & $Mod1FileName & '"'
					Case GUICtrlRead($hMP1) = $GUI_CHECKED
						$Mod1 = ' --mod_mp "' & $Mod1FileName & '"'
					Case GUICtrlRead($hGlobal1) = $GUI_CHECKED
						$Mod1 = ' --mod "' & $Mod1FileName & '"'
				EndSelect
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod2) <> "" Then
			If GUICtrlRead($hSP2) = $GUI_CHECKED Or GUICtrlRead($hMP2) = $GUI_CHECKED Or GUICtrlRead($hGlobal2) = $GUI_CHECKED Then
				$Mod2Name = GUICtrlRead($hChooseMod2)
				If FileExists(@ScriptDir & "\Mods\" & $Mod2Name) And StringRight($Mod2Name, 3) <> ".wz" Then
					$Mod2FileName = IniRead(@ScriptDir & "\Mods\" & $Mod2Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod2FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod2Name) And StringRight($Mod2Name, 3) = ".wz" Then
					$Mod2FileName = $Mod2Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP2) = $GUI_CHECKED
						$Mod2 = ' --mod_ca "' & $Mod2FileName & '"'
					Case GUICtrlRead($hMP2) = $GUI_CHECKED
						$Mod2 = ' --mod_mp "' & $Mod2FileName & '"'
					Case GUICtrlRead($hGlobal2) = $GUI_CHECKED
						$Mod2 = ' --mod "' & $Mod2FileName & '"'
				EndSelect
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod3) <> "" Then
			If GUICtrlRead($hSP3) = $GUI_CHECKED Or GUICtrlRead($hMP3) = $GUI_CHECKED Or GUICtrlRead($hGlobal3) = $GUI_CHECKED Then
				$Mod3Name = GUICtrlRead($hChooseMod3)
				If FileExists(@ScriptDir & "\Mods\" & $Mod1Name) And StringRight($Mod1Name, 3) <> ".wz" Then
					$Mod3FileName = IniRead(@ScriptDir & "\Mods\" & $Mod3Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod3FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod3Name) And StringRight($Mod3Name, 3) = ".wz" Then
					$Mod3FileName = $Mod3Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP3) = $GUI_CHECKED
						$Mod3 = ' --mod_ca "' & $Mod3FileName & '"'
					Case GUICtrlRead($hMP3) = $GUI_CHECKED
						$Mod3 = ' --mod_mp "' & $Mod3FileName & '"'
					Case GUICtrlRead($hGlobal3) = $GUI_CHECKED
						$Mod3 = ' --mod "' & $Mod3FileName & '"'
				EndSelect
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod4) <> "" Then
			If GUICtrlRead($hSP4) = $GUI_CHECKED Or GUICtrlRead($hMP4) = $GUI_CHECKED Or GUICtrlRead($hGlobal4) = $GUI_CHECKED Then
				$Mod4Name = GUICtrlRead($hChooseMod4)
				If FileExists(@ScriptDir & "\Mods\" & $Mod4Name) And StringRight($Mod4Name, 3) <> ".wz" Then
					$Mod4FileName = IniRead(@ScriptDir & "\Mods\" & $Mod4Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod4FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod4Name) And StringRight($Mod4Name, 3) = ".wz" Then
					$Mod4FileName = $Mod4Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP4) = $GUI_CHECKED
						$Mod4 = ' --mod_ca "' & $Mod4FileName & '"'
					Case GUICtrlRead($hMP4) = $GUI_CHECKED
						$Mod4 = ' --mod_mp "' & $Mod4FileName & '"'
					Case GUICtrlRead($hGlobal4) = $GUI_CHECKED
						$Mod4 = ' --mod "' & $Mod4FileName & '"'
				EndSelect
			EndIf
		EndIf
	EndIf

	If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod5) <> "" Then
			If GUICtrlRead($hSP5) = $GUI_CHECKED Or GUICtrlRead($hMP5) = $GUI_CHECKED Or GUICtrlRead($hGlobal5) = $GUI_CHECKED Then
				$Mod5Name = GUICtrlRead($hChooseMod5)
				If FileExists(@ScriptDir & "\Mods\" & $Mod5Name) And StringRight($Mod5Name, 3) <> ".wz" Then
					$Mod5FileName = IniRead(@ScriptDir & "\Mods\" & $Mod5Name & "\ModConfig.ini", "General", "ModFileName", "ERROR")
					If $Mod5FileName = "ERROR" Then Return SetError(1, 0, 1)
				ElseIf FileExists(@ScriptDir & "\Mods\" & $Mod5Name) And StringRight($Mod5Name, 3) = ".wz" Then
					$Mod5FileName = $Mod5Name
				Else
					Return SetError(2, 0, 2)
				EndIf
				Select
					Case GUICtrlRead($hSP5) = $GUI_CHECKED
						$Mod5 = ' --mod_ca "' & $Mod5FileName & '"'
					Case GUICtrlRead($hMP5) = $GUI_CHECKED
						$Mod5 = ' --mod_mp "' & $Mod5FileName & '"'
					Case GUICtrlRead($hGlobal5) = $GUI_CHECKED
						$Mod5 = ' --mod "' & $Mod5FileName & '"'
				EndSelect
			EndIf
		EndIf
	EndIf

	;Generate Command line
	GUICtrlSetData($hCurrentCommandLine, "%GameExePath%" & $Mod1 & $Mod2 & $Mod3 & $Mod4 & $Mod5 & " " & StringStripWS(GUICtrlRead($hOtherCommands), 7))

EndFunc   ;==>_UPDATE_DATA_DISPLAY_CMDLINE

Func _UPDATE_DATA_DISPLAY_SETTING()

	GUICtrlSetData($hCurrentSettingFile, GUICtrlRead($hChooseSetting))

EndFunc   ;==>_UPDATE_DATA_DISPLAY_SETTING

Func _UPDATE_DATA_DISPLAY_1()

	If GUICtrlRead($hUseMod1) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod1Display, "")
		GUICtrlSetData($hMod1State, "")
	Else
		GUICtrlSetData($hMod1Display, GUICtrlRead($hChooseMod1))
		Select
			Case GUICtrlRead($hGlobal1) = $GUI_CHECKED
				If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then GUICtrlSetData($hMod1State, "Global")
			Case GUICtrlRead($hSP1) = $GUI_CHECKED
				If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then GUICtrlSetData($hMod1State, "Campaign")
			Case GUICtrlRead($hMP1) = $GUI_CHECKED
				If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then GUICtrlSetData($hMod1State, "Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_1

Func _UPDATE_DATA_DISPLAY_2()

	If GUICtrlRead($hUseMod2) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod2Display, "")
		GUICtrlSetData($hMod2State, "")
	Else
		GUICtrlSetData($hMod2Display, GUICtrlRead($hChooseMod2))
		Select
			Case GUICtrlRead($hGlobal2) = $GUI_CHECKED
				If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then GUICtrlSetData($hMod2State, "Global")
			Case GUICtrlRead($hSP2) = $GUI_CHECKED
				If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then GUICtrlSetData($hMod2State, "Campaign")
			Case GUICtrlRead($hMP2) = $GUI_CHECKED
				If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then GUICtrlSetData($hMod2State, "Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_2

Func _UPDATE_DATA_DISPLAY_3()

	If GUICtrlRead($hUseMod3) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod3Display, "")
		GUICtrlSetData($hMod3State, "")
	Else
		GUICtrlSetData($hMod3Display, GUICtrlRead($hChooseMod3))
		Select
			Case GUICtrlRead($hGlobal3) = $GUI_CHECKED
				If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then GUICtrlSetData($hMod3State, "Global")
			Case GUICtrlRead($hSP3) = $GUI_CHECKED
				If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then GUICtrlSetData($hMod3State, "Campaign")
			Case GUICtrlRead($hMP3) = $GUI_CHECKED
				If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then GUICtrlSetData($hMod3State, "Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_3

Func _UPDATE_DATA_DISPLAY_4()

	If GUICtrlRead($hUseMod4) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod4Display, "")
		GUICtrlSetData($hMod4State, "")
	Else
		GUICtrlSetData($hMod4Display, GUICtrlRead($hChooseMod4))
		Select
			Case GUICtrlRead($hGlobal4) = $GUI_CHECKED
				If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then GUICtrlSetData($hMod4State, "Global")
			Case GUICtrlRead($hSP4) = $GUI_CHECKED
				If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then GUICtrlSetData($hMod4State, "Campaign")
			Case GUICtrlRead($hMP4) = $GUI_CHECKED
				If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then GUICtrlSetData($hMod4State, "Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_4

Func _UPDATE_DATA_DISPLAY_5()

	If GUICtrlRead($hUseMod5) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod5Display, "")
		GUICtrlSetData($hMod5State, "")
	Else
		GUICtrlSetData($hMod5Display, GUICtrlRead($hChooseMod5))
		Select
			Case GUICtrlRead($hGlobal5) = $GUI_CHECKED
				If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then GUICtrlSetData($hMod5State, "Global")
			Case GUICtrlRead($hSP5) = $GUI_CHECKED
				If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then GUICtrlSetData($hMod5State, "Campaign")
			Case GUICtrlRead($hMP5) = $GUI_CHECKED
				If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then GUICtrlSetData($hMod5State, "Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_5

Func _LOAD_WARZONE_CONFIG()
	Local $Count = 1
	While _GUICtrlEdit_GetLineCount($hConfigEdit) < _FileCountLines($WarzoneConfigPath)
		_GUICtrlEdit_AppendText($hConfigEdit, FileReadLine($WarzoneConfigPath, $Count) & @CRLF)
		$Count += 1
	WEnd
EndFunc   ;==>_LOAD_WARZONE_CONFIG

Func _SAVE_WARZONE_CONFIG()
	Local $Count = 0
	FileDelete($WarzoneConfigPath)
	While _GUICtrlEdit_GetLineCount($hConfigEdit) > $Count
		FileWriteLine($WarzoneConfigPath, _GUICtrlEdit_GetLine($hConfigEdit, $Count))
		$Count += 1
	WEnd
EndFunc   ;==>_SAVE_WARZONE_CONFIG

Func _UPDATE_LOGO_1()
	Local $ModName
	Local $LogoFileName
	$ModName = GUICtrlRead($hChooseMod1)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$LogoFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ModLogoFileName", "ERROR")
		If $LogoFileName = "ERROR" Then Return SetError(1, 0, 1)
		If $LogoFileName = "NA" Then
			GUICtrlSetImage($hMod1Logo, $DefaultLogo)
			Return SetError(0, 0, 0)
		EndIf
		GUICtrlSetImage($hMod1Logo, @ScriptDir & "\Mods\" & $ModName & "\" & $LogoFileName)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetImage($hMod1Logo, $DefaultLogo)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_LOGO_1

Func _UPDATE_LOGO_2()
	Local $ModName
	Local $LogoFileName
	$ModName = GUICtrlRead($hChooseMod2)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$LogoFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ModLogoFileName", "ERROR")
		If $LogoFileName = "ERROR" Then Return SetError(1, 0, 1)
		If $LogoFileName = "NA" Then
			GUICtrlSetImage($hMod2Logo, $DefaultLogo)
			Return SetError(0, 0, 0)
		EndIf
		GUICtrlSetImage($hMod2Logo, @ScriptDir & "\Mods\" & $ModName & "\" & $LogoFileName)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetImage($hMod2Logo, $DefaultLogo)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_LOGO_2

Func _UPDATE_LOGO_3()
	Local $ModName
	Local $LogoFileName
	$ModName = GUICtrlRead($hChooseMod3)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$LogoFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ModLogoFileName", "ERROR")
		If $LogoFileName = "ERROR" Then Return SetError(1, 0, 1)
		If $LogoFileName = "NA" Then
			GUICtrlSetImage($hMod3Logo, $DefaultLogo)
			Return SetError(0, 0, 0)
		EndIf
		GUICtrlSetImage($hMod3Logo, @ScriptDir & "\Mods\" & $ModName & "\" & $LogoFileName)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetImage($hMod3Logo, $DefaultLogo)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_LOGO_3

Func _UPDATE_LOGO_4()
	Local $ModName
	Local $LogoFileName
	$ModName = GUICtrlRead($hChooseMod4)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$LogoFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ModLogoFileName", "ERROR")
		If $LogoFileName = "ERROR" Then Return SetError(1, 0, 1)
		If $LogoFileName = "NA" Then
			GUICtrlSetImage($hMod4Logo, $DefaultLogo)
			Return SetError(0, 0, 0)
		EndIf
		GUICtrlSetImage($hMod4Logo, @ScriptDir & "\Mods\" & $ModName & "\" & $LogoFileName)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetImage($hMod4Logo, $DefaultLogo)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_LOGO_4

Func _UPDATE_LOGO_5()
	Local $ModName
	Local $LogoFileName
	$ModName = GUICtrlRead($hChooseMod5)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$LogoFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ModLogoFileName", "ERROR")
		If $LogoFileName = "ERROR" Then Return SetError(1, 0, 1)
		If $LogoFileName = "NA" Then
			GUICtrlSetImage($hMod5Logo, $DefaultLogo)
			Return SetError(0, 0, 0)
		EndIf
		GUICtrlSetImage($hMod5Logo, @ScriptDir & "\Mods\" & $ModName & "\" & $LogoFileName)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetImage($hMod5Logo, $DefaultLogo)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_LOGO_5

Func _UPDATE_DESCRIPTION_1()
	Local $ModName
	$ModName = GUICtrlRead($hChooseMod1)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		_GUICtrlEdit_AddTextFromIni(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModDescription", "LineCount", "Line", $hMod1Description)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetData($hMod1Description, "")
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_DESCRIPTION_1

Func _UPDATE_DESCRIPTION_2()
	Local $ModName
	$ModName = GUICtrlRead($hChooseMod2)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		_GUICtrlEdit_AddTextFromIni(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModDescription", "LineCount", "Line", $hMod2Description)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetData($hMod2Description, "")
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_DESCRIPTION_2

Func _UPDATE_DESCRIPTION_3()
	Local $ModName
	$ModName = GUICtrlRead($hChooseMod3)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		_GUICtrlEdit_AddTextFromIni(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModDescription", "LineCount", "Line", $hMod3Description)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetData($hMod3Description, "")
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_DESCRIPTION_3

Func _UPDATE_DESCRIPTION_4()
	Local $ModName
	$ModName = GUICtrlRead($hChooseMod4)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		_GUICtrlEdit_AddTextFromIni(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModDescription", "LineCount", "Line", $hMod4Description)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetData($hMod4Description, "")
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_DESCRIPTION_4

Func _UPDATE_DESCRIPTION_5()
	Local $ModName
	$ModName = GUICtrlRead($hChooseMod5)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		_GUICtrlEdit_AddTextFromIni(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModDescription", "LineCount", "Line", $hMod5Description)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		GUICtrlSetData($hMod5Description, "")
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_UPDATE_DESCRIPTION_5

Func _LIMIT_SCOPE_1()
	Local $ModName
	Local $Scope
	$ModName = GUICtrlRead($hChooseMod1)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$Scope = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModInfo", "ModScope", "ERROR")
		Select
			Case $Scope = "SP"
				GUICtrlSetState($hSP1, $GUI_CHECKED)
				GUICtrlSetState($hGlobal1, $GUI_DISABLE)
				GUICtrlSetState($hMP1, $GUI_DISABLE)
			Case $Scope = "MP"
				GUICtrlSetState($hMP1, $GUI_CHECKED)
				GUICtrlSetState($hSP1, $GUI_DISABLE)
				GUICtrlSetState($hGlobal1, $GUI_DISABLE)
			Case $Scope = "GLOBAL"
				GUICtrlSetState($hGlobal1, $GUI_CHECKED)
				GUICtrlSetState($hMP1, $GUI_DISABLE)
				GUICtrlSetState($hSP1, $GUI_DISABLE)
			Case $Scope = "NA"
				Return SetError(0, 0, 0)
			Case $Scope = "ERROR"
				Return SetError(1, 0, 1)
		EndSelect
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
			GUICtrlSetState($hMP1, $GUI_ENABLE)
			GUICtrlSetState($hSP1, $GUI_ENABLE)
			GUICtrlSetState($hGlobal1, $GUI_ENABLE)
		Else
			GUICtrlSetState($hMP1, $GUI_DISABLE)
			GUICtrlSetState($hSP1, $GUI_DISABLE)
			GUICtrlSetState($hGlobal1, $GUI_DISABLE)
		EndIf
		Return SetError(0, 0, 0)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_LIMIT_SCOPE_1

Func _LIMIT_SCOPE_2()
	Local $ModName
	Local $Scope
	$ModName = GUICtrlRead($hChooseMod2)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$Scope = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModInfo", "ModScope", "ERROR")
		Select
			Case $Scope = "SP"
				GUICtrlSetState($hSP2, $GUI_CHECKED)
				GUICtrlSetState($hGlobal2, $GUI_DISABLE)
				GUICtrlSetState($hMP2, $GUI_DISABLE)
			Case $Scope = "MP"
				GUICtrlSetState($hMP2, $GUI_CHECKED)
				GUICtrlSetState($hSP2, $GUI_DISABLE)
				GUICtrlSetState($hGlobal2, $GUI_DISABLE)
			Case $Scope = "GLOBAL"
				GUICtrlSetState($hGlobal2, $GUI_CHECKED)
				GUICtrlSetState($hMP2, $GUI_DISABLE)
				GUICtrlSetState($hSP2, $GUI_DISABLE)
			Case $Scope = "NA"
				Return SetError(0, 0, 0)
			Case $Scope = "ERROR"
				Return SetError(1, 0, 1)
		EndSelect
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
			GUICtrlSetState($hMP2, $GUI_ENABLE)
			GUICtrlSetState($hSP2, $GUI_ENABLE)
			GUICtrlSetState($hGlobal2, $GUI_ENABLE)
		Else
			GUICtrlSetState($hMP2, $GUI_DISABLE)
			GUICtrlSetState($hSP2, $GUI_DISABLE)
			GUICtrlSetState($hGlobal2, $GUI_DISABLE)
		EndIf
		Return SetError(0, 0, 0)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_LIMIT_SCOPE_2

Func _LIMIT_SCOPE_3()
	Local $ModName
	Local $Scope
	$ModName = GUICtrlRead($hChooseMod3)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$Scope = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModInfo", "ModScope", "ERROR")
		Select
			Case $Scope = "SP"
				GUICtrlSetState($hSP3, $GUI_CHECKED)
				GUICtrlSetState($hGlobal3, $GUI_DISABLE)
				GUICtrlSetState($hMP3, $GUI_DISABLE)
			Case $Scope = "MP"
				GUICtrlSetState($hMP3, $GUI_CHECKED)
				GUICtrlSetState($hSP3, $GUI_DISABLE)
				GUICtrlSetState($hGlobal3, $GUI_DISABLE)
			Case $Scope = "GLOBAL"
				GUICtrlSetState($hGlobal3, $GUI_CHECKED)
				GUICtrlSetState($hMP3, $GUI_DISABLE)
				GUICtrlSetState($hSP3, $GUI_DISABLE)
			Case $Scope = "NA"
				Return SetError(0, 0, 0)
			Case $Scope = "ERROR"
				Return SetError(1, 0, 1)
		EndSelect
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
			GUICtrlSetState($hMP3, $GUI_ENABLE)
			GUICtrlSetState($hSP3, $GUI_ENABLE)
			GUICtrlSetState($hGlobal3, $GUI_ENABLE)
		Else
			GUICtrlSetState($hMP3, $GUI_DISABLE)
			GUICtrlSetState($hSP3, $GUI_DISABLE)
			GUICtrlSetState($hGlobal3, $GUI_DISABLE)
		EndIf
		Return SetError(0, 0, 0)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_LIMIT_SCOPE_3

Func _LIMIT_SCOPE_4()
	Local $ModName
	Local $Scope
	$ModName = GUICtrlRead($hChooseMod4)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$Scope = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModInfo", "ModScope", "ERROR")
		Select
			Case $Scope = "SP"
				GUICtrlSetState($hSP4, $GUI_CHECKED)
				GUICtrlSetState($hGlobal4, $GUI_DISABLE)
				GUICtrlSetState($hMP4, $GUI_DISABLE)
			Case $Scope = "MP"
				GUICtrlSetState($hMP4, $GUI_CHECKED)
				GUICtrlSetState($hSP4, $GUI_DISABLE)
				GUICtrlSetState($hGlobal4, $GUI_DISABLE)
			Case $Scope = "GLOBAL"
				GUICtrlSetState($hGlobal4, $GUI_CHECKED)
				GUICtrlSetState($hMP4, $GUI_DISABLE)
				GUICtrlSetState($hSP4, $GUI_DISABLE)
			Case $Scope = "NA"
				Return SetError(0, 0, 0)
			Case $Scope = "ERROR"
				Return SetError(1, 0, 1)
		EndSelect
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
			GUICtrlSetState($hMP4, $GUI_ENABLE)
			GUICtrlSetState($hSP4, $GUI_ENABLE)
			GUICtrlSetState($hGlobal4, $GUI_ENABLE)
		Else
			GUICtrlSetState($hMP4, $GUI_DISABLE)
			GUICtrlSetState($hSP4, $GUI_DISABLE)
			GUICtrlSetState($hGlobal4, $GUI_DISABLE)
		EndIf
		Return SetError(0, 0, 0)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_LIMIT_SCOPE_4

Func _LIMIT_SCOPE_5()
	Local $ModName
	Local $Scope
	$ModName = GUICtrlRead($hChooseMod5)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$Scope = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "ModInfo", "ModScope", "ERROR")
		Select
			Case $Scope = "SP"
				GUICtrlSetState($hSP5, $GUI_CHECKED)
				GUICtrlSetState($hGlobal5, $GUI_DISABLE)
				GUICtrlSetState($hMP5, $GUI_DISABLE)
			Case $Scope = "MP"
				GUICtrlSetState($hMP5, $GUI_CHECKED)
				GUICtrlSetState($hSP5, $GUI_DISABLE)
				GUICtrlSetState($hGlobal5, $GUI_DISABLE)
			Case $Scope = "GLOBAL"
				GUICtrlSetState($hGlobal5, $GUI_CHECKED)
				GUICtrlSetState($hMP5, $GUI_DISABLE)
				GUICtrlSetState($hSP5, $GUI_DISABLE)
			Case $Scope = "NA"
				Return SetError(0, 0, 0)
			Case $Scope = "ERROR"
				Return SetError(1, 0, 1)
		EndSelect
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
			GUICtrlSetState($hMP5, $GUI_ENABLE)
			GUICtrlSetState($hSP5, $GUI_ENABLE)
			GUICtrlSetState($hGlobal5, $GUI_ENABLE)
		Else
			GUICtrlSetState($hMP5, $GUI_DISABLE)
			GUICtrlSetState($hSP5, $GUI_DISABLE)
			GUICtrlSetState($hGlobal5, $GUI_DISABLE)
		EndIf
		Return SetError(0, 0, 0)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_LIMIT_SCOPE_5

Func _OPEN_README_1()
	Local $ModName
	Local $ReadmeFileName
	If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod1)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			$ReadmeFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ReadmeFileName", "ERROR")
			If $ReadmeFileName = "ERROR" Then Return SetError(1, 0, 1)
			If $ReadmeFileName = "NA" Then
				MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
				Return SetError(0, 0, 0)
			EndIf
			ShellExecute(@ScriptDir & "\Mods\" & $ModName & "\" & $ReadmeFileName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_README_1

Func _OPEN_FOLDER_1()
	Local $ModName
	If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod1)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			ShellExecute(@ScriptDir & "\Mods\" & $ModName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			ShellExecute(@ScriptDir & "\Mods")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_FOLDER_1

Func _OPEN_README_2()
	Local $ModName
	Local $ReadmeFileName
	If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod2)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			$ReadmeFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ReadmeFileName", "ERROR")
			If $ReadmeFileName = "ERROR" Then Return SetError(1, 0, 1)
			If $ReadmeFileName = "NA" Then
				MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
				Return SetError(0, 0, 0)
			EndIf
			ShellExecute(@ScriptDir & "\Mods\" & $ModName & "\" & $ReadmeFileName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_README_2

Func _OPEN_FOLDER_2()
	Local $ModName
	If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod2)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			ShellExecute(@ScriptDir & "\Mods\" & $ModName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			ShellExecute(@ScriptDir & "\Mods")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_FOLDER_2

Func _OPEN_README_3()
	Local $ModName
	Local $ReadmeFileName
	If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod3)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			$ReadmeFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ReadmeFileName", "ERROR")
			If $ReadmeFileName = "ERROR" Then Return SetError(1, 0, 1)
			If $ReadmeFileName = "NA" Then
				MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
				Return SetError(0, 0, 0)
			EndIf
			ShellExecute(@ScriptDir & "\Mods\" & $ModName & "\" & $ReadmeFileName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_README_3

Func _OPEN_FOLDER_3()
	Local $ModName
	If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod3)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			ShellExecute(@ScriptDir & "\Mods\" & $ModName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			ShellExecute(@ScriptDir & "\Mods")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_FOLDER_3

Func _OPEN_README_4()
	Local $ModName
	Local $ReadmeFileName
	If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod4)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			$ReadmeFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ReadmeFileName", "ERROR")
			If $ReadmeFileName = "ERROR" Then Return SetError(1, 0, 1)
			If $ReadmeFileName = "NA" Then
				MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
				Return SetError(0, 0, 0)
			EndIf
			ShellExecute(@ScriptDir & "\Mods\" & $ModName & "\" & $ReadmeFileName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_README_4

Func _OPEN_FOLDER_4()
	Local $ModName
	If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod4)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			ShellExecute(@ScriptDir & "\Mods\" & $ModName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			ShellExecute(@ScriptDir & "\Mods")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_FOLDER_4

Func _OPEN_README_5()
	Local $ModName
	Local $ReadmeFileName
	If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod5)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			$ReadmeFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ReadmeFileName", "ERROR")
			If $ReadmeFileName = "ERROR" Then Return SetError(1, 0, 1)
			If $ReadmeFileName = "NA" Then
				MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
				Return SetError(0, 0, 0)
			EndIf
			ShellExecute(@ScriptDir & "\Mods\" & $ModName & "\" & $ReadmeFileName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			MsgBox(0, "Warzone 2100 Mod Manager", "There is no readme file for this mod")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_README_5

Func _OPEN_FOLDER_5()
	Local $ModName
	If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
		$ModName = GUICtrlRead($hChooseMod5)
		If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
			ShellExecute(@ScriptDir & "\Mods\" & $ModName)
		ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
			ShellExecute(@ScriptDir & "\Mods")
		Else
			Return SetError(2, 0, 2)
		EndIf
	EndIf
EndFunc   ;==>_OPEN_FOLDER_5

Func _REFRESH_LIST_BOXES()

	_GUICtrlListBox_BeginUpdate($hChooseMod1)
	_GUICtrlListBox_ResetContent($hChooseMod1)
	_GUICtrlListBox_AddDir($hChooseMod1, @ScriptDir & "\mods", "*.wz")
	_GUICtrlListBox_AddListFromIni(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "Mod", $hChooseMod1)
	_GUICtrlListBox_EndUpdate($hChooseMod1)

	_GUICtrlListBox_BeginUpdate($hChooseMod2)
	_GUICtrlListBox_ResetContent($hChooseMod2)
	_GUICtrlListBox_AddDir($hChooseMod2, @ScriptDir & "\mods", "*.wz")
	_GUICtrlListBox_AddListFromIni(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "Mod", $hChooseMod2)
	_GUICtrlListBox_EndUpdate($hChooseMod2)

	_GUICtrlListBox_BeginUpdate($hChooseMod3)
	_GUICtrlListBox_ResetContent($hChooseMod3)
	_GUICtrlListBox_AddDir($hChooseMod3, @ScriptDir & "\mods", "*.wz")
	_GUICtrlListBox_AddListFromIni(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "Mod", $hChooseMod3)
	_GUICtrlListBox_EndUpdate($hChooseMod3)

	_GUICtrlListBox_BeginUpdate($hChooseMod4)
	_GUICtrlListBox_ResetContent($hChooseMod4)
	_GUICtrlListBox_AddDir($hChooseMod4, @ScriptDir & "\mods", "*.wz")
	_GUICtrlListBox_AddListFromIni(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "Mod", $hChooseMod4)
	_GUICtrlListBox_EndUpdate($hChooseMod4)

	_GUICtrlListBox_BeginUpdate($hChooseMod5)
	_GUICtrlListBox_ResetContent($hChooseMod5)
	_GUICtrlListBox_AddDir($hChooseMod5, @ScriptDir & "\mods", "*.wz")
	_GUICtrlListBox_AddListFromIni(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "Mod", $hChooseMod5)
	_GUICtrlListBox_EndUpdate($hChooseMod5)

	_REFRESH_LIST_BOX_SETTING()

EndFunc   ;==>_REFRESH_LIST_BOXES

Func _REFRESH_LIST_BOX_SETTING()

	_GUICtrlListBox_BeginUpdate($hChooseSetting)
	_GUICtrlListBox_ResetContent($hChooseSetting)
	_GUICtrlListBox_AddDir($hChooseSetting, @ScriptDir & "\Setting Files", "*.set")
	_GUICtrlListBox_EndUpdate($hChooseSetting)
	_GUICtrlListBox_SelectString($hChooseSetting, StringTrimRight(StringTrimLeft($CurrentSetting, StringInStr($CurrentSetting, "\", 0, -1)), 1))

EndFunc   ;==>_REFRESH_LIST_BOX_SETTING

Func _LOAD_SETTINGS()

	Local $ModFile1
	Local $ModScope1
	Local $ModFile2
	Local $ModScope2
	Local $ModFile3
	Local $ModScope3
	Local $ModFile4
	Local $ModScope4
	Local $ModFile5
	Local $ModScope5

	GUICtrlSetData($hOtherCommands, IniRead($CurrentSetting, "General", "OtherCommands", ""))

	$ModFile1 = IniRead($CurrentSetting, "Setting1", "ModFile", "ERROR")
	$ModScope1 = IniRead($CurrentSetting, "Setting1", "ModScope", "ERROR")

	If $ModFile1 <> "ERROR" And $ModFile1 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod1)
		_GUICtrlListBox_SelectString($hChooseMod1, IniRead($CurrentSetting, "Setting1", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod1)
		GUICtrlSetState($hUseMod1, $GUI_CHECKED)
		_ToggleMod1()
		_LIMIT_SCOPE_1()
		Switch $ModScope1
			Case "SP"
				GUICtrlSetState($hSP1, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP1, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal1, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod1, $GUI_UNCHECKED)
		_ToggleMod1()
		_LIMIT_SCOPE_1()
	EndIf

	$ModFile2 = IniRead($CurrentSetting, "Setting2", "ModFile", "ERROR")
	$ModScope2 = IniRead($CurrentSetting, "Setting2", "ModScope", "ERROR")

	If $ModFile2 <> "ERROR" And $ModFile2 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod2)
		_GUICtrlListBox_SelectString($hChooseMod2, IniRead($CurrentSetting, "Setting2", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod2)
		GUICtrlSetState($hUseMod2, $GUI_CHECKED)
		_ToggleMod2()
		_LIMIT_SCOPE_2()
		Switch $ModScope2
			Case "SP"
				GUICtrlSetState($hSP2, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP2, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal2, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod2, $GUI_UNCHECKED)
		_ToggleMod2()
		_LIMIT_SCOPE_2()
	EndIf

	$ModFile3 = IniRead($CurrentSetting, "Setting3", "ModFile", "ERROR")
	$ModScope3 = IniRead($CurrentSetting, "Setting3", "ModScope", "ERROR")

	If $ModFile3 <> "ERROR" And $ModFile3 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod3)
		_GUICtrlListBox_SelectString($hChooseMod3, IniRead($CurrentSetting, "Setting3", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod3)
		GUICtrlSetState($hUseMod3, $GUI_CHECKED)
		_ToggleMod3()
		_LIMIT_SCOPE_3()
		Switch $ModScope3
			Case "SP"
				GUICtrlSetState($hSP3, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP3, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal3, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod3, $GUI_UNCHECKED)
		_ToggleMod3()
		_LIMIT_SCOPE_3()
	EndIf

	$ModFile4 = IniRead($CurrentSetting, "Setting4", "ModFile", "ERROR")
	$ModScope4 = IniRead($CurrentSetting, "Setting4", "ModScope", "ERROR")

	If $ModFile4 <> "ERROR" And $ModFile4 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod4)
		_GUICtrlListBox_SelectString($hChooseMod4, IniRead($CurrentSetting, "Setting4", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod4)
		GUICtrlSetState($hUseMod4, $GUI_CHECKED)
		_ToggleMod4()
		_LIMIT_SCOPE_4()
		Switch $ModScope4
			Case "SP"
				GUICtrlSetState($hSP4, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP4, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal4, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod4, $GUI_UNCHECKED)
		_ToggleMod4()
		_LIMIT_SCOPE_4()
	EndIf

	$ModFile5 = IniRead($CurrentSetting, "Setting5", "ModFile", "ERROR")
	$ModScope5 = IniRead($CurrentSetting, "Setting5", "ModScope", "ERROR")

	If $ModFile5 <> "ERROR" And $ModFile5 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod5)
		_GUICtrlListBox_SelectString($hChooseMod5, IniRead($CurrentSetting, "Setting5", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod5)
		GUICtrlSetState($hUseMod5, $GUI_CHECKED)
		_ToggleMod5()
		_LIMIT_SCOPE_5()
		Switch $ModScope5
			Case "SP"
				GUICtrlSetState($hSP5, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP5, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal5, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod5, $GUI_UNCHECKED)
		_ToggleMod5()
		_LIMIT_SCOPE_5()
	EndIf

	MsgBox(0, "Warzone 2100 Mod Manager", "Settings Loaded")

EndFunc   ;==>_LOAD_SETTINGS

Func _SAVE_SETTINGS()

	;Setting 1
	If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
		IniWrite($CurrentSetting, "Setting1", "ModFile", GUICtrlRead($hChooseMod1))
		Select
			Case GUICtrlRead($hSP1) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting1", "ModScope", "SP")
			Case GUICtrlRead($hMP1) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting1", "ModScope", "MP")
			Case GUICtrlRead($hGlobal1) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting1", "ModScope", "Global")
			Case Else
				IniWrite($CurrentSetting, "Setting1", "ModScope", "")
		EndSelect
	Else
		IniWrite($CurrentSetting, "Setting1", "ModFile", "")
		IniWrite($CurrentSetting, "Setting1", "ModScope", "")
	EndIf

	;Setting 2
	If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
		IniWrite($CurrentSetting, "Setting2", "ModFile", GUICtrlRead($hChooseMod2))
		Select
			Case GUICtrlRead($hSP2) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting2", "ModScope", "SP")
			Case GUICtrlRead($hMP2) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting2", "ModScope", "MP")
			Case GUICtrlRead($hGlobal2) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting2", "ModScope", "Global")
			Case Else
				IniWrite($CurrentSetting, "Setting2", "ModScope", "")
		EndSelect
	Else
		IniWrite($CurrentSetting, "Setting2", "ModFile", "")
		IniWrite($CurrentSetting, "Setting2", "ModScope", "")
	EndIf

	;Setting 3
	If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
		IniWrite($CurrentSetting, "Setting3", "ModFile", GUICtrlRead($hChooseMod3))
		Select
			Case GUICtrlRead($hSP3) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting3", "ModScope", "SP")
			Case GUICtrlRead($hMP3) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting3", "ModScope", "MP")
			Case GUICtrlRead($hGlobal3) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting3", "ModScope", "Global")
			Case Else
				IniWrite($CurrentSetting, "Setting3", "ModScope", "")
		EndSelect
	Else
		IniWrite($CurrentSetting, "Setting3", "ModFile", "")
		IniWrite($CurrentSetting, "Setting3", "ModScope", "")
	EndIf

	;Setting 4
	If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
		IniWrite($CurrentSetting, "Setting4", "ModFile", GUICtrlRead($hChooseMod4))
		Select
			Case GUICtrlRead($hSP4) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting4", "ModScope", "SP")
			Case GUICtrlRead($hMP4) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting4", "ModScope", "MP")
			Case GUICtrlRead($hGlobal4) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting4", "ModScope", "Global")
			Case Else
				IniWrite($CurrentSetting, "Setting4", "ModScope", "")
		EndSelect
	Else
		IniWrite($CurrentSetting, "Setting4", "ModFile", "")
		IniWrite($CurrentSetting, "Setting4", "ModScope", "")
	EndIf

	;Setting 5
	If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
		IniWrite($CurrentSetting, "Setting5", "ModFile", GUICtrlRead($hChooseMod5))
		Select
			Case GUICtrlRead($hSP5) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting5", "ModScope", "SP")
			Case GUICtrlRead($hMP5) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting5", "ModScope", "MP")
			Case GUICtrlRead($hGlobal5) = $GUI_CHECKED
				IniWrite($CurrentSetting, "Setting5", "ModScope", "Global")
			Case Else
				IniWrite($CurrentSetting, "Setting5", "ModScope", "")
		EndSelect
	Else
		IniWrite($CurrentSetting, "Setting5", "ModFile", "")
		IniWrite($CurrentSetting, "Setting5", "ModScope", "")
	EndIf

	;Other Commands
	IniWrite($CurrentSetting, "General", "OtherCommands", GUICtrlRead($hOtherCommands))

	MsgBox(0, "Warzone 2100 Mod Manager", "Setting Saved to Selected File")

EndFunc   ;==>_SAVE_SETTINGS

Func _CREATE_SETTING_FILE()

	Local $Blank
	Local $Save
	Local $msgGUI
	Local $winCreateSetting

	;GUI
	$winCreateSetting = GUICreate("Warzone 2100 Mod Manager", 304, 66, -1, -1)

	$Blank = GUICtrlCreateButton("Create Empty Setting File", 2, 2, 300, 30)
	$Save = GUICtrlCreateButton("Create Setting File With Currently Selected Mods", 2, 34, 300, 30)

	GUISetState()

	;MSG loop
	While 1
		$msgGUI = GUIGetMsg()
		Select

			Case $msgGUI = $GUI_EVENT_CLOSE

				ExitLoop

			Case $msgGUI = $Blank

				Local $RTN
				$RTN = InputBox("Create Setting", "Enter name for new setting file.", "", " M", 300, 80)

				If @error <> 1 Then
					_FileCreate(@ScriptDir & "\Setting Files\" & $RTN & ".set")
					MsgBox(0, "Create Setting", "Setting file Created.")
					;$CurrentSetting = (@ScriptDir & "\Setting Files\" & $RTN & ".set")
					_REFRESH_LIST_BOX_SETTING()
					ExitLoop
				EndIf

			Case $msgGUI = $Save

				Local $RTN
				$RTN = InputBox("Create Setting", "Enter name for new setting file.", "", " M", 300, 80)

				If @error <> 1 Then
					_FileCreate(@ScriptDir & "\Setting Files\" & $RTN & ".set")
					MsgBox(0, "Create Setting", "Setting file Created.")
					$CurrentSetting = (@ScriptDir & "\Setting Files\" & $RTN & ".set")
					_SAVE_SETTINGS()
					_REFRESH_LIST_BOX_SETTING()
					_GUICtrlListBox_BeginUpdate($hChooseSetting)
					_GUICtrlListBox_SelectString($hChooseSetting, $RTN & ".set")
					_GUICtrlListBox_EndUpdate($hChooseSetting)
					ExitLoop
				EndIf

		EndSelect
	WEnd
	GUIDelete($winCreateSetting)
EndFunc   ;==>_CREATE_SETTING_FILE

Func _INSTALL_TO_WARZONE_MOD_FOLDER($ModName, $Scope, $GameExePath)
	Local $ModFileName
	Local $GameDirPath = StringLeft($GameExePath, StringInStr($GameExePath, "\", 0, -1) - 1)
	If FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) <> ".wz" Then
		$ModFileName = IniRead(@ScriptDir & "\Mods\" & $ModName & "\ModConfig.ini", "General", "ModFileName", "ERROR")
		If $ModFileName = "ERROR" Then Return SetError(1, 0, 1)
		Select
			Case $Scope = "MP"
				FileCopy(@ScriptDir & "\Mods\" & $ModName & "\" & $ModFileName, $GameDirPath & "\mods\multiplay\" & $ModFileName)
			Case $Scope = "SP"
				FileCopy(@ScriptDir & "\Mods\" & $ModName & "\" & $ModFileName, $GameDirPath & "\mods\campaign\" & $ModFileName)
			Case $Scope = "GLOBAL"
				FileCopy(@ScriptDir & "\Mods\" & $ModName & "\" & $ModFileName, $GameDirPath & "\mods\global\" & $ModFileName)
		EndSelect
		Return SetError(0, 0, 0)
	ElseIf FileExists(@ScriptDir & "\Mods\" & $ModName) And StringRight($ModName, 3) = ".wz" Then
		$ModFileName = $ModName
		Select
			Case $Scope = "MP"
				FileCopy(@ScriptDir & "\Mods\" & $ModFileName, $GameDirPath & "\mods\multiplay\" & $ModFileName)
			Case $Scope = "SP"
				FileCopy(@ScriptDir & "\Mods\" & $ModFileName, $GameDirPath & "\mods\campaign\" & $ModFileName)
			Case $Scope = "GLOBAL"
				FileCopy(@ScriptDir & "\Mods\" & $ModFileName, $GameDirPath & "\mods\global\" & $ModFileName)
		EndSelect
		Return SetError(0, 0, 0)
	Else
		Return SetError(2, 0, 2)
	EndIf
EndFunc   ;==>_INSTALL_TO_WARZONE_MOD_FOLDER

Func _SETUP()

	Local $Default
	Local $Custom
	Local $RTN
	Local $SetupYN
	Local $msgGUI

	$SetupYN = IniRead(@ScriptDir & "\Config.ini", "General", "SetupYN", "ERROR")

	If $SetupYN = "N" Then
		Return
	EndIf

	;GUI
	GUICreate("Warzone 2100 Mod Manager Setup", 550, 68, -1, -1)

	$Default = GUICtrlCreateButton("Click Here If You Have Installed ""Warzone2100.exe"" to ""%Program Files%\Warzone 2100"". (Default for 2.2.X)", 2, 2, 546, 30)
	$Custom = GUICtrlCreateButton("Click Here If Your .exe is NOT named ""Warzone2100.exe"" or is installed to a different path.", 2, 34, 546, 30)

	GUISetState()

	;MSG loop
	While 1
		$msgGUI = GUIGetMsg()
		Select
			Case $msgGUI = $GUI_EVENT_CLOSE
				Exit
			Case $msgGUI = $Default
				DirCreate(@ScriptDir & "\Setting Files")
				DirCreate(@ScriptDir & "\Mods")
				IniWrite(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "0")
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameExePath", @ProgramFilesDir & "\Warzone 2100\warzone2100.exe")
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameConfigPath", _
						FileOpenDialog("Warzone 2100 Mod Manager Setup", @MyDocumentsDir, "Warzone Config File (*)", 1, "config"))
				IniWrite(@ScriptDir & "\Config.ini", "General", "SetupYN", "N")
				_MOVE_MODS_TO_MANAGER_MOD_DIR(@ProgramFilesDir & "\Warzone 2100\warzone2100.exe")
				_REGISTER_WZMOD_FILES()
				GUIDelete()
				Return
			Case $msgGUI = $Custom
				$RTN = FileOpenDialog("Warzone 2100 Mod Manager Setup", @HomeDrive, "EXE Files (*.exe)", 1)
				DirCreate(@ScriptDir & "\Setting Files")
				DirCreate(@ScriptDir & "\Mods")
				IniWrite(@ScriptDir & "\Mods\Installed Mods.ini", "InstalledModList", "Count", "0")
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameExePath", $RTN)
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameConfigPath", _
						FileOpenDialog("Warzone 2100 Mod Manager Setup", @MyDocumentsDir, "Warzone Config File (*)", 1, "config"))
				IniWrite(@ScriptDir & "\Config.ini", "General", "SetupYN", "N")
				_MOVE_MODS_TO_MANAGER_MOD_DIR($RTN)
				_REGISTER_WZMOD_FILES()
				GUIDelete()
				Return
		EndSelect
	WEnd
EndFunc   ;==>_SETUP

Func _MOVE_MODS_TO_MANAGER_MOD_DIR($GameExePath)
	MsgBox(0, "Warzone 2100 Mod Manager Setup", "Setup will now move all your mods to the mod manager mod directory.")
	Local $GameDirPath = StringLeft($GameExePath, StringInStr($GameExePath, "\", 0, -1) - 1)
	FileMove($GameDirPath & "\mods\multiplay\*.wz", @ScriptDir & "\Mods\*.*", 0)
	FileMove($GameDirPath & "\mods\campaign\*.wz", @ScriptDir & "\Mods\*.*", 0)
	FileMove($GameDirPath & "\mods\global\*.wz", @ScriptDir & "\Mods\*.*", 0)
EndFunc   ;==>_MOVE_MODS_TO_MANAGER_MOD_DIR

Func _REGISTER_WZMOD_FILES()
	$RTN = MsgBox(36, "Warzone 2100 Mod Manager Setup", "Do you want to register .wzmod files so they install when you double click them?" & @CRLF _
			 & "If you do not register .wzmod files just drag and drop them onto the program exe to install")
	If $RTN = 7 Then Return
	RegWrite("HKEY_CLASSES_ROOT\.wzmod", "", "REG_SZ", "Warzone 2100 Mod Manager Mod File")
	RegWrite("HKEY_CLASSES_ROOT\.wzmod\shell")
	RegWrite("HKEY_CLASSES_ROOT\.wzmod\shell\Install Mod", "", "REG_SZ", "Install This Mod")
	RegWrite("HKEY_CLASSES_ROOT\.wzmod\shell\Install Mod\command", "", "REG_SZ", """" & @ScriptDir & "\Warzone 2100 Mod Manager v4.exe"" ""%L""")
	MsgBox(64, "Warzone 2100 Mod Manager Setup", ".wzmod file registered to ""Warzone 2100 Mod Manager v4.exe""")
EndFunc   ;==>_REGISTER_WZMOD_FILES

Func _DELETE_WZMOD_REGISTRATION()
	RegDelete("HKEY_CLASSES_ROOT\.wzmod")
	MsgBox(64, "Warzone 2100 Mod Manager Setup", "Registry information for .wzmod files deleted.")
EndFunc   ;==>_DELETE_WZMOD_REGISTRATION

Func _GUICtrlListBox_AddListFromIni($FileName, $SectionName, $CountKeyName, $BaseKeyName, $CtrlHandle)
	Local $KeyCount = IniRead($FileName, $SectionName, $CountKeyName, "ERROR")
	If $KeyCount = "ERROR" Then Return SetError(1, 0, 1)
	Local $Count = 0
	While $Count < $KeyCount
		Local $RTN = IniRead($FileName, $SectionName, $BaseKeyName & ($Count + 1), "ERROR")
		If $RTN = "ERROR" Then Return SetError(2, 0, ($Count + 1))
		_GUICtrlListBox_AddString($CtrlHandle, $RTN)
		$Count += 1
	WEnd
	Return SetError(0, 0, 0)
EndFunc   ;==>_GUICtrlListBox_AddListFromIni

Func _GUICtrlListBox_AddDir($CtrlHandle, $Dir, $FileName)
	Local $test
	Local $Count = 1
	$test = _FileListToArray($Dir, $FileName, 1)
	If @error = 4 Then
		Return
	ElseIf @error <> 0 Then
		MSG_ERROR("ERROR  @error = " & @error & "  _GUICtrlListBox_AddDir(" & $CtrlHandle & "," & $Dir & "," & $FileName & ")" & @CRLF & @CRLF _
				 & "Most likely a missing folder, if @error = 1 try creating  """ & $Dir & """")
		Return
	EndIf
	While $Count <= $test[0]
		_GUICtrlListBox_AddString($CtrlHandle, $test[$Count])
		$Count += 1
	WEnd
EndFunc   ;==>_GUICtrlListBox_AddDir

Func _GUICtrlEdit_AddTextFromIni($FileName, $SectionName, $CountKeyName, $BaseKeyName, $CtrlHandle)
	GUICtrlSetData($CtrlHandle, "")
	Local $KeyCount = IniRead($FileName, $SectionName, $CountKeyName, "ERROR")
	If $KeyCount = "ERROR" Then Return SetError(1, 0, 1)
	Local $Count = 0
	While $Count < $KeyCount
		Local $RTN = IniRead($FileName, $SectionName, $BaseKeyName & ($Count + 1), "ERROR")
		If $RTN = "ERROR" Then Return SetError(2, 0, ($Count + 1))
		If $Count = 0 Then
			GUICtrlSetData($CtrlHandle, $RTN)
		Else
			_GUICtrlEdit_AppendText($CtrlHandle, @CRLF & $RTN)
		EndIf
		$Count += 1
	WEnd
	Return SetError(0, 0, 0)
EndFunc   ;==>_GUICtrlEdit_AddTextFromIni

;Function-Decleration-End-------------------------------------------------------